#include <stdio.h>
#include <string.h>
#include <stdlib.h>

struct sample {
	float x;
	float y;
};

struct sample s[] = { { 0.0, 0.0 },
							 { 0.5, 0.0 },
							 { 0.0, 2.0 },
							 { 2.0, 2.0 },
							 { 2.5, 8.0 },
							 { 6.0, 3.0 },
							 { 7.0, 3.0 } };

float sqerr( char* );

main()
{
	float err;
	int numb, i;
	char buff[ 80 ], cl[ 8 ][ 10 ];

	for ( i = 0; i < 7; i++ )
		printf( "data point %d: %f %f\n", i + 1, s[ i ].x, s[ i ].y );

	for ( ; ; ) {
		printf( "\n\nNext string (EOF to quit): " );
		if ( fgets( buff, 80, stdin ) == NULL )
			break;
		numb = sscanf( buff, "%s%s%s%s%s%s%s", cl[ 0 ], cl[ 1 ],
							cl[ 2 ], cl[ 3 ], cl[ 4 ], cl[ 5 ], cl[ 6 ] );
		err = 0.0;
		for ( i = 0; i < numb; i++ )
			err += sqerr( cl[ i ] );
		printf( "squared error = %f\n\n", err );
	}
	return EXIT_SUCCESS;
}

float sqerr( char *str )
{
	float x_bar, y_bar, err, diff;
	int count, i;
	char *st = str;

	x_bar = y_bar = err = 0.0;
	count = strlen( str );
	for ( i = 0; i < count; i++ ) {
		x_bar += s[ *st - '0' - 1 ].x;
		y_bar += s[ *st++ - '0' - 1 ].y;
	}
	x_bar /= count;
	y_bar /= count;
	st = str;
	for ( i = 0; i < count; i++ ) {
		diff = s[ *st - '0' - 1 ].x - x_bar;
		err += diff * diff;
		diff = s[ *st++ - '0' - 1 ].y - y_bar;
		err += diff * diff;
	}
	return err;
}
